Function GetError(Value: Word): String;
Begin
  Case Value Of
    0: GetError:= 'No error occurred';
    1: GetError:= 'Invalid function number';
    2: GetError:= 'File not found';
    3: GetError:= 'Path not found';
    4: GetError:= 'Too many open files (no handles left)';
    5: GetError:= 'Access denied';
    6: GetError:= 'Invalid handle';
    7: GetError:= 'Memory control blocks destroyed';
    8: GetError:= 'Insufficient memory';
    9: GetError:= 'Invalid memory-block address';
    10: GetError:= 'Invalid environment';
    11: GetError:= 'Invalid format';
    12: GetError:= 'Invalid access code';
    13: GetError:= 'Invalid data';
    14: GetError:= 'Cannot copy file, highest extension already in use';
    15: GetError:= 'Invalid drive specified';
    16: GetError:= 'Attempting to remove current directory';
    17: GetError:= 'Not same device';
    18: GetError:= 'No more files';
    19: GetError:= 'Attempt to write on write-protected diskette';
    20: GetError:= 'Unknown unit';
    21: GetError:= 'Drive not ready';
    22: GetError:= 'Unknown command';
    23: GetError:= 'Data error - cyclic redundancy check';
    24: GetError:= 'Invalid request structure length';
    25: GetError:= 'Seek error';
    26: GetError:= 'Unknown media type';
    27: GetError:= 'Sector not found';
    28: GetError:= 'Printer is out of paper';
    29: GetError:= 'Write fault';
    30: GetError:= 'Read fault';
    31: GetError:= 'General failure. For DosGetShrSeg and DosGetNamedSharedMem';
{                   ',indicates that a segment''s maximum reference count of 65535 has been exceeded';}
    32: GetError:= 'Sharing violation';
    33: GetError:= 'Lock violation';
    34: GetError:= 'Invalid disk change';
    35: GetError:= 'FCB unavailable';
    36: GetError:= 'Sharing buffer overflow';
    37: GetError:= 'Code page does not match';
    38: GetError:= 'End of file reached';
    39: GetError:= 'Disk is full';
    50: GetError:= 'Network request not supported';
    51: GetError:= 'Remote network node is not online';
    52: GetError:= 'Duplicate file name in network';
    53: GetError:= 'Network path not found';
    54: GetError:= 'Network is busy';
    55: GetError:= 'Device is not installed in network';
    56: GetError:= 'Network command limit reached';
    57: GetError:= 'Network adapter hardware error';
    58: GetError:= 'Incorrect response in network';
    59: GetError:= 'Unexpected error in network';
    60: GetError:= 'Remote network adapter error';
    61: GetError:= 'Network printer queue is full';
    62: GetError:= 'No space in print spool file';
    63: GetError:= 'Print spool file deleted';
    64: GetError:= 'Network name deleted';
    65: GetError:= 'Access to network denied';
    66: GetError:= 'Device type invalid for network';
    67: GetError:= 'Network name not found';
    68: GetError:= 'Network name limit exceeded';
    69: GetError:= 'Network session limit exceeded';
    70: GetError:= 'Temporary pause in network';
    71: GetError:= 'Network request denied';
    72: GetError:= 'Pause in network print disk redirection';
    73: GetError:= 'Attempted write on protected disk';
    74: GetError:= 'General failure, single-byte character set';
    75: GetError:= 'XGA is out of memory';
    80: GetError:= 'File exists';
    82: GetError:= 'Cannot make directory entry';
    83: GetError:= 'Failure on INT 24';
    84: GetError:= 'Too many redirections';
    85: GetError:= 'Duplicate redirection';
    86: GetError:= 'Invalid password';
    87: GetError:= 'Invalid parameter';
    88: GetError:= 'Network device fault';
    89: GetError:= 'No process slots available';
    90: GetError:= 'System error';
    91: GetError:= 'Timer service table overflow';
    92: GetError:= 'Timer service table duplicate';
    93: GetError:= 'No items to work on';
    95: GetError:= 'Interrupted system call';
    99: GetError:= 'Device in use';
    100: GetError:= 'User/system open semaphore limit reached';
    101: GetError:= 'Exclusive semaphore already owned';
    102: GetError:= 'DosCloseSem found semaphore set';
    103: GetError:= 'Too many exclusive semaphore requests';
    104: GetError:= 'Operation invalid at interrupt time';
    105: GetError:= 'Previous semaphore owner terminated without freeing semaphore';
    106: GetError:= 'Semaphore limit exceeded';
    107: GetError:= 'Insert drive B disk into drive A';
    108: GetError:= 'Drive locked by another process';
    109: GetError:= 'Write on pipe with no reader';
    110: GetError:= 'Open/create failed due to explicit fail command';
    111: GetError:= 'Buffer passed to system call too small to hold return data';
    112: GetError:= 'Not enough space on the disk';
    113: GetError:= 'Cannot allocate another search structure and handle';
    114: GetError:= 'Target handle in DosDupHandle invalid';
    115: GetError:= 'Invalid user virtual address';
    116: GetError:= 'Error on display write or keyboard read';
    117: GetError:= 'Category for DevIOCtl not defined';
    118: GetError:= 'Invalid value passed for verify flag';
    119: GetError:= 'Level four driver not found';
{
  120   Error_Call_Not_Implemented
          Invalid function called.

  121   Error_Sem_Timeout
          Time-out occurred from semaphore API function.

  122   Error_Insufficient_Buffer
          Data buffer too small.

  123   Error_Invalid_Name
          Illegal character or invalid file-system name.

  124   Error_Invalid_Level
          Non-implemented level for information retrieval or setting.

  125   Error_No_Volume_Label
          No volume label found with DosQueryFSInfo function.

  126   Error_Mod_Not_Found
          Module handle not found with DosQueryProcAddr(), DosQueryModAddr().

  127   Error_Proc_Not_Found
          Procedure address not found with DosQueryProcAddr().

  128   Error_Wait_No_Children
          DosWaitChild finds no children.

  129   Error_Child_Not_Complete
          DosWaitChild children not terminated.

  130   Error_Direct_Access_Handle
          Handle operation invalid for direct disk-access handles.

  131   Error_Negative_Seek
          Attempting seek to negative offset.

  132   Error_Seek_On_Device
          Application trying to seek on device or pipe.

  133   Error_Is_Join_Target
          Drive has previously joined drives.

  134   Error_Is_Joined
          Drive is already joined.

  135   Error_Is_Substed
          Drive is already substituted.

  136   Error_Not_Joined
          Cannot delete drive that is not joined.

  137   Error_Not_Substed
          Cannot delete drive that is not substituted.

  138   Error_Join_To_Join
          Cannot join to a joined drive.

  139   Error_Subst_To_Subst
          Cannot substitute to a substituted drive.

  140   Error_Join_To_Subst
          Cannot join to a substituted drive.

  141   Error_Subst_To_Join
          Cannot substitute to a joined drive.

  142   Error_Busy_Drive
          Specified drive is busy.

  143   Error_Same_Drive
          Cannot join or substitute a drive to a directory on the same drive.

  144   Error_Dir_Not_Root
          Directory must be a subdirectory of the root.

  145   Error_Dir_Not_Empty
          Directory must be empty to use join command.

  146   Error_Is_Subst_Path
          Path specified is being used in a substitute.

  147   Error_Is_Join_Path
          Path specified is being used in a join.

  148   Error_Path_Busy
          Path specified is being used by another process.

  149   Error_Is_Subst_Target
          Cannot join or substitute a drive that has a directory that is the target
          of a previous substitute.

  150   Error_System_Trace
          System trace error.

  151   Error_Invalid_Event_Count
          DosWaitMuxWaitSem errors.

  152   Error_Too_Many_Muxwaiters
          System limit of 100 entries reached.

  153   Error_Invalid_List_Format
          Invalid list format.

  154   Error_Label_Too_Long
          Volume label too big.

  155   Error_Too_Many_Tcbs
          Cannot create another TCB.

  156   Error_Signal_Refused
          Signal refused.

  157   Error_Discarded
          Segment is discarded.

  158   Error_Not_Locked
          Segment is not locked.

  159   Error_Bad_Threadid_Addr
          Invalid thread-identity address.

  160   Error_Bad_Arguments
          Invalid environment pointer.

  161   Error_Bad_Pathname
          Invalid path name passed to exec.

  162   Error_Signal_Pending
          Signal already pending.

  163   Error_Uncertain_Media
          Error with INT 24 mapping.

  164   Error_Max_Thrds_Reached
          No more process slots.

  165   Error_Monitors_Not_Supported
          Error with INT 24 mapping.

  166   Error_Unc_Driver_Not_Installed
          Default redirection return code.

  167   Error_Lock_Failed
          Locking failed.

  168   Error_Swapio_Failed
          Swap I/O failed.

  169   Error_Swapin_Failed
          Swap in failed.

  170   Error_Busy
          Segment is busy.

  171-172   Reserved.


  173   Error_Cancel_Violation
          A lock request is not outstanding for the specified file range, or the
          range length is zero.

  174   Error_Atomic_Lock_Not_Supported
          The file-system driver (FSD) does not support atomic lock operations.
          Versions of OS/2 prior to version 2.00 do not support atomic lock
          operations.

  175   Error_Read_Locks_Not_Supported
          The file system driver (FSD) does not support shared read locks.

  176-179   Reserved.


  180   Error_Invalid_Segment_Number
          Invalid segment number.

  181   Error_Invalid_Callgate
          Invalid call gate.

  182   Error_Invalid_Ordinal
          Invalid ordinal.

  183   Error_Already_Exists
          Shared segment already exists.

  184   Error_No_Child_Process
          No child process to wait for.

  185   Error_Child_Alive_Nowait
          NoWait specified and child alive.

  186   Error_Invalid_Flag_Number
          Invalid flag number.

  187   Error_Sem_Not_Found
          Semaphore does not exist.

  188   Error_Invalid_Starting_Codeseg
          Invalid starting code segment, incorrect END (label) directive.

  189   Error_Invalid_Stackseg
          Invalid stack segment.

  190   Error_Invalid_Moduletype
          Invalid module type - dynamic-link library file cannot be used as an
          application. Application cannot be used as a dynamic-link library.

  191   Error_Invalid_Exe_Signature
          Invalid EXE signature - file is a DOS mode program or an improper
          program.

  192   Error_Exe_Marked_Invalid
          EXE marked invalid - link detected errors when the application was
          created.

  193   Error_Bad_Exe_Format
          Invalid EXE format - file is a DOS mode program or an improper
          program.

  194   Error_Iterated_Data_Exceeds_64k
          Iterated data exceeds 64KB - there is more than 64KB of data in one of
          the segments of the file.

  195   Error_Invalid_Minallocsize
          Invalid minimum allocation size - the size is specified to be less than
          the size of the segment data in the file.

  196   Error_Dynlink_From_Invalid_Ring
          Dynamic link from invalid privilege level - privilege level 2 routine
          cannot link to dynamic-link libraries.

  197   Error_Iopl_Not_Enabled
          IOPL not enabled - IOPL set to NO in CONFIG.SYS.

  198   Error_Invalid_Segdpl
          Invalid segment descriptor privilege level - can only have privilege
          levels of 2 and 3.

  199   Error_Autodataseg_Exceeds_64k
          Automatic data segment exceeds 64KB.



 The following shows the numerical value of an error, its symbolic name, and a
 brief description of the error.

  200   Error_Ring2seg_Must_Be_Movable
          Privilege level 2 segment must be movable.

  201   Error_Reloc_Chain_Xeeds_Seglim
          Relocation chain exceeds segment limit.

  202   Error_Infloop_In_Reloc_Chain
          Infinite loop in relocation chain segment.

  203   Error_Envvar_Not_Found
          Environment variable not found.

  204   Error_Not_Current_Ctry
          Not current country.

  205   Error_No_Signal_Sent
          No signal sent - no process in the command subtree has a signal
          handler.

  206   Error_Filename_Exced_Range
          File name or extension is greater than 8.3 characters.

  207   Error_Ring2_Stack_In_Use
          Privilege level 2 stack is in use.

  208   Error_Meta_Expansion_Too_Long
          Meta (global) expansion is too long.

  209   Error_Invalid_Signal_Number
          Invalid signal number.

  210   Error_Thread_1_Inactive
          Inactive thread.

  211   Error_Info_Not_Avail
          File system information is not available for this file.

  212   Error_Locked
          Locked error.

  213   Error_Bad_Dynalink
          Attempted to execute a non-family API in DOS mode.

  214   Error_Too_Many_Modules
          Too many modules.

  215   Error_Nesting_Not_Allowed
          Nesting is not allowed.

  216   Error_Cannot_Shrink
          System error.

  217   Error_Zombie_Process
          Zombie process.

  218   Error_Stack_In_High_Memory
          Stack is in high memory.

  219   Error_Invalid_Exitroutine_Ring
          Invalid exit routine ring.

  220   Error_GetBuf_Failed
          Get buffer failed.

  221   Error_FlushBuf_Failed
          Flush buffer failed.

  222   Error_Transfer_Too_Long
          Transfer is too long.

  223   Error_ForceNoSwap_Failed
          System error.

  224   Error_Smg_No_Target_Window
          The application window was created without the FCF_TASKLIST style,
          or the application window not yet been created or has already been
          destroyed.

  228   Error_No_Children
          No child process.

  229   Error_Invalid_Screen_Group
          Invalid session.

  230   Error_Bad_Pipe
          Non-existent pipe or invalid operation.

  231   Error_Pipe_Busy
          Pipe is busy.

  232   Error_No_Data
          No data available on non-blocking read.

  233   Error_Pipe_Not_Connected
          Pipe was disconnected by server.

  234   Error_More_Data
          More data is available.

  240   Error_Vc_Disconnected
          Session was dropped due to errors.

  250   Error_Circularity_Requested
          Renaming a directory that would cause a circularity problem.

  251   Error_Directory_In_Cds
          Renaming a directory that is in use.

  252   Error_Invalid_Fsd_Name
          Trying to access nonexistent FSD.

  253   Error_Invalid_Path
          Invalid pseudo device.

  254   Error_Invalid_Ea_Name
          Invalid character in name, or invalid cbName.

  255   Error_Ea_List_Inconsistent
          List does not match its size, or there are invalid EAs in the list.

  256   Error_Ea_List_Too_Long
          FEAList is longer than 64K-1 bytes.

  257   Error_No_Meta_Match
          String does not match expression.

  258   Error_FindNotify_Timeout
          System error.

  259   Error_No_More_Items
          DosQueryFSAttach ordinal query.

  260   Error_Search_Struc_Reused
          DOS mode findfirst/next search structure reused.

  261   Error_Char_Not_Found
          Character not found.

  262   Error_Too_Much_Stack
          Stack request exceeds system limit.

  263   Error_Invalid_Attr
          Invalid attribute.

  264   Error_Invalid_Starting_Ring
          Invalid starting ring.

  265   Error_Invalid_Dll_Init_Ring
          Invalid DLL INIT ring.

  266   Error_Cannot_Copy
          Cannot copy.

  267   Error_Directory
          Used by DOSCOPY in doscall1.

  268   Error_Oplocked_File
          Oplocked file.

  269   Error_Oplock_Thread_Exists
          Oplock thread exists.

  270   Error_Volume_Changed
          Volume changed.

  271   Error_FindNotify_Handle_In_Use
          Handle in use.

  272   Error_FindNotify_Handle_Closed
          Handle closed.

  273   Error_Notify_Object_Removed
          Object removed.

  274   Error_Already_Shutdown
          System is already shut down.

  275   Error_Eas_Didnt_Fit
          Buffer is not big enough to hold the EAs.

  276   Error_Ea_File_Corrupt
          EA file has been damaged.

  277   Error_Ea_Table_Full
          EA table is full.

  278   Error_Invalid_Ea_Handle
          EA handle is invalid.

  279   Error_No_Cluster
          No cluster.

  280   Error_Create_Ea_File
          Cannot create the EA file.

  281   Error_Cannot_Open_Ea_File
          Cannot open the EA file.

  282   Error_Eas_Not_Supported
          Destination file system does not support EAs.

  283   Error_Need_Eas_Found
          Destination file system does not support EAs, and the source file's EAs
          contain a need EA.

  284   Error_Duplicate_Handle
          The handle already exists.

  285   Error_Duplicate_Name
          The name already exists.

  286   Error_Empty_Muxwait
          The list of semaphores in a muxwait semaphore is empty.

  287   Error_Mutex_Owned
          The calling thread owns one or more of the mutex semaphores in the
          list.

  288   Error_Not_Owner
          Caller does not own the semaphore.

  289   Error_Param_Too_Small
          Parameter is not large enough to contain all of the semaphore records in
          the muxwait semaphore.

  290   Error_Too_Many_Handles
          Limit reached for number of handles.

  291   Error_Too_Many_Opens
          There are too many files or semaphores open.

  292   Error_Wrong_Type
          Attempted to create wrong type of semaphore.

  293   Error_Unused_Code
          Code is not used.

  294   Error_Thread_Not_Terminated
          Thread has not terminated.

  295   Error_Init_Routine_Failed
          Initialization routine failed.

  296   Error_Module_In_Use
          Module is in use.

  297   Error_Not_Enough_Watchpoints
          There are not enough watchpoints.

  298   Error_Too_Many_Posts
          Post count limit was reached for an event semaphore.

  299   Error_Already_Posted
          Event semaphore is already posted.



 The following shows the numerical value of an error, its symbolic name, and a
 brief description of the error.

  300   Error_Already_Reset
          Event semaphore is already reset.

  301   Error_Sem_Busy
          Semaphore is busy.

  302   Reserved


  303   Error_Invalid_Procid
          Invalid process identity.

  304   Error_Invalid_Pdelta
          Invalid priority delta.

  305   Error_Not_Descendant
          Not descendant.

  306   Error_Not_Session_Manager
          Requestor not session manager.

  307   Error_Invalid_Pclass
          Invalid P class.

  308   Error_Invalid_Scope
          Invalid scope.

  309   Error_Invalid_Threadid
          Invalid thread identity.

  310   Error_Dossub_Shrink
          Cannot shrink segment - DosSubSetMem.

  311   Error_Dossub_Nomem
          No memory to satisfy request - DosSubAllocMem.

  312   Error_Dossub_Overlap
          Overlap of the specified block with a block of allocated memory -
          DosSubFreeMem.

  313   Error_Dossub_Badsize
          Invalid size parameter - DosSubAllocMem or DosSubFreeMem.

  314   Error_Dossub_Badflag
          Invalid flag parameter - DosSubSetMem.

  315   Error_Dossub_Badselector
          Invalid segment selector.

  316   Error_Mr_Msg_Too_Long
          Message too long for buffer.

  317   Error_Mr_Mid_Not_Found
          Message identity number not found.

  318   Error_Mr_Un_Acc_Msgf
          Unable to access message file.

  319   Error_Mr_Inv_Msgf_Format
          Invalid message file format.

  320   Error_Mr_Inv_Ivcount
          Invalid insertion variable count.

  321   Error_Mr_Un_Perform
          Unable to perform function.

  322   Error_Ts_Wakeup
          Unable to wake up.

  323   Error_Ts_Semhandle
          Invalid system semaphore.

  324   Error_Ts_Notimer
          No timers available.

  326   Error_Ts_Handle
          Invalid timer handle.

  327   Error_Ts_Datetime
          Date or time invalid.

  328   Error_Sys_Internal
          Internal system error.

  329   Error_Que_Current_Name
          Current queue name does not exist.

  330   Error_Que_Proc_Not_Owned
          Current process does not own queue.

  331   Error_Que_Proc_Owned
          Current process owns queue.

  332   Error_Que_Duplicate
          Duplicate queue name.

  333   Error_Que_Element_Not_Exist
          Queue element does not exist.

  334   Error_Que_No_Memory
          Inadequate queue memory.

          For DosOpenQueue, DosCreateQueue, and DosWriteQueue, the following
          applies: These calls use a system-wide pool of memory. Every
          DosOpenQueue and DosCreateQueue uses up 34 bytes of memory, which
          is freed on close. Every DosWriteQueue uses 24 bytes of memory, which
          is freed on read. If too many elements are written to queues, further
          opens, creates, reads, or writes fail with this error code.

  335   Error_Que_Invalid_Name
          Invalid queue name.

  336   Error_Que_Invalid_Priority
          Invalid queue priority parameter.

  337   Error_Que_Invalid_Handle
          Invalid queue handle.

  338   Error_Que_Link_Not_Found
          Queue link not found.

  339   Error_Que_Memory_Error
          Queue memory error.

  340   Error_Que_Prev_At_End
          Previous queue element was at end of queue.

  341   Error_Que_Proc_No_Access
          Process does not have access to queues.

  342   Error_Que_Empty
          Queue is empty.

  343   Error_Que_Name_Not_Exist
          Queue name does not exist.

  344   Error_Que_Not_Initialized
          Queues not initialized.

  345   Error_Que_Unable_To_Access
          Unable to access queues.

  346   Error_Que_Unable_To_Add
          Unable to add new queue.

  347   Error_Que_Unable_To_Init
          Unable to initialize queues.

  349   Error_Vio_Invalid_Mask
          Invalid function replaced.

  350   Error_Vio_Ptr
          Invalid pointer to parameter.

  351   Error_Vio_Aptr
          Invalid pointer to attribute.

  352   Error_Vio_Rptr
          Invalid pointer to row.

  353   Error_Vio_Cptr
          Invalid pointer to column.

  354   Error_Vio_Lptr
          Invalid pointer to length.

  355   Error_Vio_Mode
          Unsupported screen mode.

  356   Error_Vio_Width
          Invalid cursor width value.

  357   Error_Vio_Attr
          Invalid cursor attribute value.

  358   Error_Vio_Row
          Invalid row value.

  359   Error_Vio_Col
          Invalid column value.

  360   Error_Vio_Toprow
          Invalid TopRow value.

  361   Error_Vio_Botrow
          Invalid BotRow value.

  362   Error_Vio_Rightcol
          Invalid right column value.

  363   Error_Vio_Leftcol
          Invalid left column value.

  364   Error_Scs_Call
          Call issued by other than session manager.

  365   Error_Scs_Value
          Value is not for save or restore.

  366   Error_Vio_Wait_Flag
          Invalid wait flag setting.

  367   Error_Vio_Unlock
          Screen not previously locked.

  368   Error_Sgs_Not_Session_Mgr
          Caller not session manager.

  369   Error_Smg_Invalid_Sgid
          Invalid session identity.

  369   Error_Smg_Invalid_Session_Id
          Invalid session ID.

  370   Error_Smg_Nosg
          No sessions available.

  370   Error_Smg_No_Sessions
          No sessions available.

  371   Error_Smg_Grp_Not_Found
          Session not found.

  371   Error_Smg_Session_Not_Found
          Session not found.

  372   Error_Smg_Set_Title
          Title sent by shell or parent cannot be changed.

  373   Error_Kbd_Parameter
          Invalid parameter to keyboard.

  374   Error_Kbd_No_Device
          No device.

  375   Error_Kbd_Invalid_Iowait
          Invalid I/O wait specified.

  376   Error_Kbd_Invalid_Length
          Invalid length for keyboard.

  377   Error_Kbd_Invalid_Echo_Mask
          Invalid echo mode mask.

  378   Error_Kbd_Invalid_Input_Mask
          Invalid input mode mask.

  379   Error_Mon_Invalid_Parms
          Invalid parameters to DosMon.

  380   Error_Mon_Invalid_Devname
          Invalid device name string.

  381   Error_Mon_Invalid_Handle
          Invalid device handle.

  382   Error_Mon_Buffer_Too_Small
          Buffer too small.

  383   Error_Mon_Buffer_Empty
          Buffer is empty.

  384   Error_Mon_Data_Too_Large
          Data record is too large.

  385   Error_Mouse_No_Device
          Mouse device closed (invalid device handle).

  386   Error_Mouse_Inv_Handle
          Mouse device closed (invalid device handle).

  387   Error_Mouse_Inv_Parms
          Parameters invalid for display mode.

  388   Error_Mouse_Cant_Reset
          Function assigned and cannot be reset.

  389   Error_Mouse_Display_Parms
          Parameters invalid for display mode.

  390   Error_Mouse_Inv_Module
          Module not valid.

  391   Error_Mouse_Inv_Entry_Pt
          Entry point not valid.

  392   Error_Mouse_Inv_Mask
          Function mask invalid.

  393   NO_Error_Mouse_No_Data
          No valid data.

  394   NO_Error_Mouse_Ptr_Drawn
          Pointer drawn.

  395   Error_Invalid_Frequency
          Invalid frequency for beep.

  396   Error_Nls_No_Country_File
          Cannot find COUNTRY.SYS file.

  397   Error_Nls_Open_Failed
          Cannot open COUNTRY.SYS file.

  398   Error_Nls_No_Ctry_Code
          Country code not found.

  398   Error_No_Country_Or_Codepage
          Country code not found.

  399   Error_Nls_Table_Truncated
          Table returned information truncated, buffer is too small.



 The following shows the numerical value of an error, its symbolic name, and a
 brief description of the error.

  400   Error_Nls_Bad_Type
          Selected type does not exist.

  401   Error_Nls_Type_Not_Found
          Selected type is not in file.

  402   Error_Vio_Smg_Only
          Valid from session manager only.

  403   Error_Vio_Invalid_Asciiz
          Invalid ASCIIZ length.

  404   Error_Vio_Deregister
          VioDeRegister not allowed.

  405   Error_Vio_No_Popup
          Pop-up window not allocated.

  406   Error_Vio_Existing_Popup
          Pop-up window on screen (NoWait).

  407   Error_Kbd_Smg_Only
          Valid from session manager only.

  408   Error_Kbd_Invalid_Asciiz
          Invalid ASCIIZ length.

  409   Error_Kbd_Invalid_Mask
          Invalid replacement mask.

  410   Error_Kbd_Register
          KbdRegister not allowed.

  411   Error_Kbd_Deregister
          KbdDeRegister not allowed.

  412   Error_Mouse_Smg_Only
          Valid from session manager only.

  413   Error_Mouse_Invalid_Asciiz
          Invalid ASCIIZ length.

  414   Error_Mouse_Invalid_Mask
          Invalid replacement mask.

  415   Error_Mouse_Register
          Mouse register not allowed.

  416   Error_Mouse_Deregister
          Mouse deregister not allowed.

  417   Error_Smg_Bad_Action
          Invalid action specified.

  418   Error_Smg_Invalid_Call
          INIT called more than once, or invalid session identity.

  419   Error_Scs_Sg_Notfound
          New session number.

  420   Error_Scs_Not_Shell
          Caller is not shell.

  421   Error_Vio_Invalid_Parms
          Invalid parameters passed.

  422   Error_Vio_Function_Owned
          Save/restore already owned.

  423   Error_Vio_Return
          Non-destruct return (undo).

  424   Error_Scs_Invalid_Function
          Caller invalid function.

  425   Error_Scs_Not_Session_Mgr
          Caller not session manager.

  426   Error_Vio_Register
          Vio register not allowed.

  427   Error_Vio_No_Mode_Thread
          No mode restore thread in SG.

  428   Error_Vio_No_Save_Restore_Thd
          No save/restore thread in SG.

  429   Error_Vio_In_Bg
          Function invalid in background.

  430   Error_Vio_Illegal_During_Popup
          Function not allowed during pop-up window.

  431   Error_Smg_Not_Baseshell
          Caller is not the base shell.

  432   Error_Smg_Bad_Statusreq
          Invalid status requested.

  433   Error_Que_Invalid_Wait
          NoWait parameter out of bounds.

  434   Error_Vio_Lock
          Error returned from Scroll Lock.

  435   Error_Mouse_Invalid_Iowait
          Invalid parameters for IOWait.

  436   Error_Vio_Invalid_Handle
          Invalid VIO handle.

  437   Error_Vio_Illegal_During_Lock
          Function not allowed during screen lock.

  438   Error_Vio_Invalid_Length
          Invalid VIO length.

  439   Error_Kbd_Invalid_Handle
          Invalid KBD handle.

  440   Error_Kbd_No_More_Handle
          Ran out of handles.

  441   Error_Kbd_Cannot_Create_Kcb
          Unable to create kcb.

  442   Error_Kbd_Codepage_Load_Incompl
          Unsuccessful code-page load.

  443   Error_Kbd_Invalid_Codepage_Id
          Invalid code-page identity.

  444   Error_Kbd_No_Codepage_Support
          No code page support.

  445   Error_Kbd_Focus_Required
          Keyboard focus required.

  446   Error_Kbd_Focus_Already_Active
          Calling thread has an outstanding focus.

  447   Error_Kbd_Keyboard_Busy
          Keyboard is busy.

  448   Error_Kbd_Invalid_Codepage
          Invalid code page.

  449   Error_Kbd_Unable_To_Focus
          Focus attempt failed.

  450   Error_Smg_Session_Non_Select
          Session is not selectable.

  451   Error_Smg_Session_Not_Foregrnd
          Parent/child session is not foreground.

  452   Error_Smg_Session_Not_Parent
          Not parent of requested child.

  453   Error_Smg_Invalid_Start_Mode
          Invalid session start mode.

  454   Error_Smg_Invalid_Related_Opt
          Invalid session start related option.

  455   Error_Smg_Invalid_Bond_Option
          Invalid session bond option.

  456   Error_Smg_Invalid_Select_Opt
          Invalid session select option.

  457   Error_Smg_Start_In_Background
          Session started in background.

  458   Error_Smg_Invalid_Stop_Option
          Invalid session stop option.

  459   Error_Smg_Bad_Reserve
          Reserved parameters are not zero.

  460   Error_Smg_Process_Not_Parent
          Session parent process already exists.

  461   Error_Smg_Invalid_Data_Length
          Invalid data length.

  462   Error_Smg_Not_Bound
          Parent is not bound.

  463   Error_Smg_Retry_Sub_Alloc
          Retry request block allocation.

  464   Error_Kbd_Detached
          This call is not allowed for a detached PID.

  465   Error_Vio_Detached
          This call is not allowed for a detached PID.

  466   Error_Mou_Detached
          This call is not allowed for a detached PID.

  467   Error_Vio_Font
          No font is available to support the mode.

  468   Error_Vio_User_Font
          User font is active.

  469   Error_Vio_Bad_Cp
          Invalid code page specified.

  470   Error_Vio_No_Cp
          System displays do not support code page.

  471   Error_Vio_Na_Cp
          Current display does not support code page.

  472   Error_Invalid_Code_Page
          Invalid code page.

  473   Error_CpList_Too_Small
          Code page list is too small.

  474   Error_Cp_Not_Moved
          Code page was not moved.

  475   Error_Mode_Switch_Init
          Mode switch initialization error.

  476   Error_Code_Page_Not_Found
          Code page was not found.

  477   Error_Unexpected_Slot_Returned
          Internal error.

  478   Error_Smg_Invalid_Trace_Option
          Invalid start session trace indicator.

  479   Error_Vio_Internal_Resource
          VIO internal resource error.

  480   Error_Vio_Shell_Init
          VIO shell initialization error.

  481   Error_Smg_No_Hard_Errors
          No session manager hard errors.

  482   Error_Cp_Switch_Incomplete
          DosSetProcessCp is unable to set a KBD or VIO code page.

  483   Error_Vio_Transparent_Popup
          Error during VIO pop-up window.

  484   Error_CritSec_Overflow
          Critical section overflow.

  485   Error_CritSec_Underflow
          Critical section underflow.

  486   Error_Vio_Bad_Reserve
          Reserved parameter is not zero.

  487   Error_Invalid_Address
          Invalid physical address.

  488   Error_Zero_Selectors_Requested
          At least one selector must be requested.

  489   Error_Not_Enough_Selectors_Ava
          Not enough GDT selectors to satisfy request.

  490   Error_Invalid_Selector
          Not a GDT selector.

  491   Error_Smg_Invalid_Program_Type
          Invalid program type.

  492   Error_Smg_Invalid_Pgm_Control
          Invalid program control.

  493   Error_Smg_Invalid_Inherit_Opt
          Invalid inherit option.

  494   Error_Vio_Extended_Sg


  495   Error_Vio_Not_Pres_Mgr_Sg


  496   Error_Vio_Shield_Owned


  497   Error_Vio_No_More_Handles


  498   Error_Vio_See_Error_Log


  499   Error_Vio_Associated_Dc




 The following shows the numerical value of an error, and its symbolic name.

  500   Error_Kbd_No_Console


  501   Error_Mouse_No_Console


  502   Error_Mouse_Invalid_Handle


  503   Error_Smg_Invalid_Debug_Parms


  504   Error_Kbd_Extended_Sg


  505   Error_Mou_Extended_Sg


  506   Error_Smg_Invalid_Icon_File


  507   Error_Trc_Pid_Non_Existent


  508   Error_Trc_Count_Active


  509   Error_Trc_Suspended_By_Count


  510   Error_Trc_Count_Inactive


  511   Error_Trc_Count_Reached


  512   Error_No_Mc_Trace


  513   Error_Mc_Trace


  514   Error_Trc_Count_Zero


  515   Error_Smg_Too_Many_Dds


  516   Error_Smg_Invalid_Notification


  517   Error_Lf_Invalid_Function


  518   Error_Lf_Not_Avail


  519   Error_Lf_Suspended


  520   Error_Lf_Buf_Too_Small


  521   Error_Lf_Buffer_Corrupted


  521   Error_Lf_Buffer_Full


  522   Error_Lf_Invalid_Daemon


  522   Error_Lf_Invalid_Record


  523   Error_Lf_Invalid_Templ


  523   Error_Lf_Invalid_Service


  524   Error_Lf_General_Failure


  525   Error_Lf_Invalid_Id


  526   Error_Lf_Invalid_Handle


  527   Error_Lf_No_Id_Avail


  528   Error_Lf_Template_Area_Full


  529   Error_Lf_Id_In_Use


  530   Error_Mou_Not_Initialized


  531   Error_Mouinitreal_Done


  532   Error_Dossub_Corrupted


  533   Error_Mouse_Caller_Not_Subsys


  534   Error_Arithmetic_Overflow


  535   Error_Tmr_No_Device


  536   Error_Tmr_Invalid_Time


  537   Error_Pvw_Invalid_Entity


  538   Error_Pvw_Invalid_Entity_Type


  539   Error_Pvw_Invalid_Spec


  540   Error_Pvw_Invalid_Range_Type


  541   Error_Pvw_Invalid_Counter_Blk


  542   Error_Pvw_Invalid_Text_Blk


  543   Error_Prf_Not_Initialized


  544   Error_Prf_Already_Initialized


  545   Error_Prf_Not_Started


  546   Error_Prf_Already_Started


  547   Error_Prf_Timer_Out_Of_Range


  548   Error_Prf_Timer_Reset


  549-599 Reserved.




 The following shows the numerical value of an error, and its symbolic name.

  600-638 Reserved.


  639   Error_VDD_Lock_Useage_Denied


  640   Error_Timeout


  641   Error_VDM_Down


  642   Error_VDM_Limit


  643   Error_VDD_Not_Found


  644   Error_Invalid_Caller


  645   Error_Pid_Mismatch


  646   Error_Invalid_Vdd_Handle


  647   Error_VLPT_No_Spooler


  648   Error_VCOM_Device_Busy


  649   Error_VLPT_Device_Busy


  650   Error_Nesting_Too_Deep


  651   Error_VDD_Missing


  691   Error_Imp_Invalid_Parm


  692   Error_Imp_Invalid_Length


  693   msg_HPFS_Disk_Error_Warn


  730   Error_Mon_Bad_Buffer


  731   Error_Module_Corrupted


  732-1476 Reserved.


  1477  Error_Sm_OutOf_SwapFile


  1478-1999 Reserved.




 The following shows the numerical value of an error, and its symbolic name.

  2000-2054 Reserved.


  2055   Error_Lf_Timeout


  2057   Error_Lf_Suspend_Success


  2058   Error_Lf_Resume_Success


  2059   Error_Lf_Redirect_Success


  2060   Error_Lf_Redirect_Failure


  32768   Error_Swapper_Not_Active


  32769   Error_Invalid_Swapid


  32770   Error_Ioerr_Swap_File


  32771   Error_Swap_Table_Full


  32772   Error_Swap_File_Full


  32773   Error_Cant_Init_Swapper


  32774   Error_Swapper_Already_Init


  32775   Error_Pmm_Insufficient_Memory


  32776   Error_Pmm_Invalid_Flags


  32777   Error_Pmm_Invalid_Address


  32778   Error_Pmm_Lock_Failed


  32779   Error_Pmm_Unlock_Failed


  32780   Error_Pmm_Move_Incomplete


  32781   Error_Ucom_Drive_Renamed


  32782   Error_Ucom_Filename_Truncated


  32783   Error_Ucom_Buffer_Length


  32784   Error_Mon_Chain_Handle


  32785   Error_Mon_Not_Registered


  32786   Error_Smg_Already_Top


  32787   Error_Pmm_Arena_Modified


  32788   Error_Smg_Printer_Open


  32789   Error_Pmm_Set_Flags_Failed


  32790   Error_Invalid_Dos_Dd


  32791   Error_Blocked


  32792   Error_NoBlock


  32793   Error_Instance_Shared


  32794   Error_No_Object


  32795   Error_Partial_Attach


  32796   Error_Incache


  32797   Error_Swap_IO_Problems


  32798   Error_Crosses_Object_Boundary


  32799   Error_LongLock


  32800   Error_ShortLock


  32801   Error_UVirtLock


  32802   Error_AliasLock


  32803   Error_Alias


  32804   Error_No_More_Handles


  32805   Error_Scan_Terminated


  32806   Error_Terminator_Not_Found


  32807   Error_Not_Direct_Child


  32808   Error_Delay_Free


  32809   Error_Guardpage


  32900   Error_Swaperror


  32901   Error_Ldrerror


  32902   Error_Nomemory


  32903   Error_Noaccess


  32904   Error_No_Dll_Term


  32905-59999 Reserved.




 The following shows the numerical value of an error, and its symbolic name.

  6000-65025 Reserved.


  65026   Error_Cpsio_Code_Page_Invalid


  65027   Error_Cpsio_No_Spooler


  65028   Error_Cpsio_Font_Id_Invalid


  65029-65032 Reserved.


  65033   Error_Cpsio_Internal_Error


  65034   Error_Cpsio_Invalid_Ptr_Name


  65035-65036 Reserved.


  65037   Error_Cpsio_Not_Active


  65038   Reserved.


  65039   Error_Cpsio_Pid_Full


  65040   Error_Cpsio_Pid_Not_Found


  65041-65042 Reserved.


  65043   Error_Cpsio_Read_Ctl_Seq


  65044   Reserved.


  65045   Error_Cpsio_Read_Fnt_Def


  65046   Reserved.


  65047   Error_Cpsio_Write_Error


  65048   Error_Cpsio_Write_Full_Error


  65049   Error_Cpsio_Write_Handle_Bad


  65050-65073 Reserved.


  65074   Error_Cpsio_Swit_Load


  65075-65076 Reserved.


  65077   Error_Cpsio_Inv_Command


  65078   Error_Cpsio_No_Font_Swit             }


    65079: GetError:= 'Error_Entry_Is_CallGate';
    Else GetError:= 'Unknow error'
  End
End;
